'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

exports.default = decorateHistory;

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function decorateHistory(w, history) {
  function bind(event, callback) {
    if (typeof callback !== 'function') {
      throw new Error('Callback function is required to bind event.');
    }

    callback.appManagerId = _constants.APP_MANAGER_ID; // eslint-disable-line no-param-reassign
    history.Adapter.bind(w, event, callback);
  }

  function unbind(event) {
    var uid = history.Adapter.uid(w);

    if (uid && history.Adapter.handlers[uid]) {
      var wHandlers = history.Adapter.handlers[uid];

      if (Array.isArray(wHandlers[event])) {
        wHandlers[event] = wHandlers[event].filter(function (callback) {
          return callback.appManagerId !== _constants.APP_MANAGER_ID;
        });
      }
    }
  }

  function trigger(event, data) {
    history.Adapter.trigger(w, event, data);
  }

  return (0, _assign2.default)({}, history, { events: { bind: bind, unbind: unbind, trigger: trigger } });
}